scala.tools.nsc.backend.icode.analysis.TypeFlowAnalysis

# MTFAGrowable

###
Related Doc: package TypeFlowAnalysis

#### class MTFAGrowable extends MethodTFA

A full type-flow analysis on a method computes in- and out-flows for each basic block (that's what MethodTFA does).

For the purposes of Inliner, doing so guarantees that an abstract typestack-slot is available by the time an inlining candidate (a CALL_METHOD instruction) is visited. This subclass (MTFAGrowable) of MethodTFA also aims at performing such analysis on CALL_METHOD instructions, with some differences:

(a) early screening is performed while the type-flow is being computed (in an override of `blockTransfer`) by testing a subset of the conditions that Inliner checks later. The reasoning here is: if the early check fails at some iteration, there's no chance a follow-up iteration (with a yet more lub-ed typestack-slot) will succeed. Failure is sufficient to remove that particular CALL_METHOD from the typeflow's `remainingCALLs`. A forward note: in case inlining occurs at some basic block B, all blocks reachable from B get their CALL_METHOD instructions considered again as candidates (because of the more precise types that -- perhaps -- can be computed).

(b) in case the early check does not fail, no conclusive decision can be made, thus the CALL_METHOD stays `isOnwatchlist`.

In other words, `remainingCALLs` tracks those callsites that still remain as candidates for inlining, so that Inliner can focus on those. `remainingCALLs` also caches info about the typestack just before the callsite, so as to spare computing them again at inlining time.

Besides caching, a further optimization involves skipping those basic blocks whose in-flow and out-flow isn't needed anyway (as explained next). A basic block lacking a callsite in `remainingCALLs`, when visited by the standard algorithm, won't cause any inlining. But as we know from the way type-flows are computed, computing the in- and out-flow for a basic block relies in general on those of other basic blocks. In detail, we want to focus on that sub-graph of the CFG such that control flow may reach a remaining candidate callsite. Those basic blocks not in that subgraph can be skipped altogether. That's why:

- `forwardAnalysis()` in `MTFAGrowable` now checks for inclusion of a basic block in `relevantBBs`
- same check is performed before adding a block to the worklist, and as part of choosing successors. The bookkeeping supporting on-the-fly pruning of irrelevant blocks requires overriding most methods of the dataflow-analysis.

The rest of the story takes place in Inliner, which does not visit all of the method's basic blocks but only on those represented in `remainingCALLs`.

Source
  TypeFlowAnalysis.scala

Linear Supertypes
MethodTFA, DataFlowAnalysis[typeFlowLattice.type], AnyRef, Any
Type Hierarchy Learn more about scaladoc diagrams
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. MTFAGrowable
2. MethodTFA
3. DataFlowAnalysis
4. AnyRef
5. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show all

Visibility

1. Public
2. All

### Instance Constructors

1. #### new MTFAGrowable()

### Type Members

1. #### case class Bind (l: Global.icodes.Local, t: InferredType) extends Gen with Product with Serializable

   Definition Classes
     MethodTFA

2. #### case class Const (t: Global.icodes.TypeKind) extends InferredType with Product with Serializable

   A type that does not depend on input to the transfer function.

   A type that does not depend on input to the transfer function.

   Definition Classes
     MethodTFA

3. #### abstract class Gen extends AnyRef

   Definition Classes
     MethodTFA

4. #### abstract class InferredType extends AnyRef

   Definition Classes
     MethodTFA

5. #### type P = Global.icodes.BasicBlock

   A type for program points.

   A type for program points.

   Definition Classes
     MethodTFA → DataFlowAnalysis

6. #### case class Push (t: InferredType) extends Gen with Product with Serializable

   Definition Classes
     MethodTFA

7. #### class TransferFunction extends (Elem) ⇒ Elem

   A flow transfer function of a basic block.

   A flow transfer function of a basic block.

   Definition Classes
     MethodTFA

8. #### case class TypeOfStackPos (n: Int) extends InferredType with Product with Serializable

   The type found at a stack position.

   The type found at a stack position.

   Definition Classes
     MethodTFA

9. #### case class TypeOfVar (l: Global.icodes.Local) extends InferredType with Product with Serializable

   The type of a given local variable.

   The type of a given local variable.

   Definition Classes
     MethodTFA

### Value Members

1. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     AnyRef → Any

2. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types and `null`.

   Equivalent to `x.hashCode` except for boxed numeric types and `null`. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them. For `null` returns a hashcode where `null.hashCode` throws a `NullPointerException`.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

3. #### def +(other: String): String

   Implicit information
     This member is added by an implicit conversion from MTFAGrowable to any2stringadd[MTFAGrowable] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd

4. #### def ->[B](y: B): (MTFAGrowable, B)

   Implicit information
     This member is added by an implicit conversion from MTFAGrowable to ArrowAssoc[MTFAGrowable] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()

5. #### final def ==(arg0: Any): Boolean

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   arg0

     the object to compare against this object for equality.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     AnyRef → Any

6. #### val STRING: Global.icodes.REFERENCE

   Definition Classes
     MethodTFA

7. #### final def asInstanceOf[T0]: T0

   Cast the receiver object to be of type `T0`.

   Cast the receiver object to be of type `T0`.

   Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

   returns

     the receiver object.

   Definition Classes
     Any
   Exceptions thrown

     `ClassCastException` if the receiver object is not an instance of the erasure of type `T0`.

8. #### def backwardAnalysis(f: (P, Elem) ⇒ Elem): Unit

   Definition Classes
     DataFlowAnalysis

9. #### final def blackballed(msym: Global.Symbol): Boolean

10. #### def blockTransfer(b: Global.icodes.BasicBlock, in: Elem): Elem

    Definition Classes
      MTFAGrowable → MethodTFA

11. #### var callerLin: Traversable[Global.icodes.BasicBlock]

12. #### def clone(): AnyRef

    Create a copy of the receiver object.

    Create a copy of the receiver object.

    The default implementation of the `clone` method is platform dependent.

    returns

      a copy of the receiver object.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
    Note

      not specified by SLS as a member of AnyRef

13. #### def conclusives(b: Global.icodes.BasicBlock): List[CALL_METHOD]

14. #### def ensuring(cond: (MTFAGrowable) ⇒ Boolean, msg: ⇒ Any): MTFAGrowable

    Implicit information
      This member is added by an implicit conversion from MTFAGrowable to Ensuring[MTFAGrowable] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

15. #### def ensuring(cond: (MTFAGrowable) ⇒ Boolean): MTFAGrowable

    Implicit information
      This member is added by an implicit conversion from MTFAGrowable to Ensuring[MTFAGrowable] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

16. #### def ensuring(cond: Boolean, msg: ⇒ Any): MTFAGrowable

    Implicit information
      This member is added by an implicit conversion from MTFAGrowable to Ensuring[MTFAGrowable] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

17. #### def ensuring(cond: Boolean): MTFAGrowable

    Implicit information
      This member is added by an implicit conversion from MTFAGrowable to Ensuring[MTFAGrowable] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

18. #### final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

19. #### def equals(arg0: Any): Boolean

    The equality method for reference types.

    The equality method for reference types. Default implementation delegates to `eq`.

    See also `equals` in scala.Any.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      AnyRef → Any

20. #### def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )
    Note

      not specified by SLS as a member of AnyRef

21. #### def formatted(fmtstr: String): String

    Implicit information
      This member is added by an implicit conversion from MTFAGrowable to StringFormat[MTFAGrowable] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()

22. #### def forwardAnalysis(f: (P, Elem) ⇒ Elem): Unit

    Implements forward dataflow analysis: the transfer function is applied when inputs to a Program point change, to obtain the new output value.

    Implements forward dataflow analysis: the transfer function is applied when inputs to a Program point change, to obtain the new output value.

    f

      the transfer function.

    Definition Classes
      MTFAGrowable → DataFlowAnalysis

23. #### final def getClass(): Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Note

      not specified by SLS as a member of AnyRef

24. #### def hasNoRelevantSuccs(x: Global.icodes.BasicBlock): Boolean

25. #### def hashCode(): Int

    The hashCode method for reference types.

    The hashCode method for reference types. See hashCode in scala.Any.

    returns

      the hash code value for this object.

    Definition Classes
      AnyRef → Any

26. #### val in: Map[P, Elem]

    Definition Classes
      DataFlowAnalysis

27. #### def init(m: Global.icodes.IMethod): Unit

    Initialize the in/out maps for the analysis of the given method.

    Initialize the in/out maps for the analysis of the given method.

    Definition Classes
      MTFAGrowable → MethodTFA

28. #### def init(f: ⇒ Unit): Unit

    Definition Classes
      DataFlowAnalysis

29. #### def interpret(in: Elem, i: Global.icodes.Instruction): Elem

    Abstract interpretation for one instruction.

    Abstract interpretation for one instruction.

    Definition Classes
      MethodTFA

30. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

31. #### val isOnWatchlist: Set[Global.icodes.Instruction]

32. #### def isWatching(x: Global.icodes.BasicBlock): Boolean

33. #### var iterations: Int

    the number of times we iterated before reaching a fixpoint.

    the number of times we iterated before reaching a fixpoint.

    Definition Classes
      DataFlowAnalysis

34. #### def knownBeforehand(b: Global.icodes.BasicBlock): List[CALL_METHOD]

35. #### val knownNever: Set[Global.Symbol]

36. #### val knownSafe: Set[Global.Symbol]

37. #### val knownUnsafe: Set[Global.Symbol]

38. #### val lattice: typeFlowLattice.type

    Definition Classes
      MethodTFA → DataFlowAnalysis

39. #### var method: Global.icodes.IMethod

    Definition Classes
      MethodTFA

40. #### def mutatingInterpret(out: Elem, i: Global.icodes.Instruction): Elem

    Definition Classes
      MethodTFA

41. #### final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

42. #### final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

43. #### final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

44. #### val out: Map[P, Elem]

    Definition Classes
      DataFlowAnalysis

45. #### val preCandidates: Set[Global.icodes.BasicBlock]

46. #### def reinit(m: Global.icodes.IMethod, staleOut: List[Global.icodes.BasicBlock], inlined: Set[Global.icodes.BasicBlock], staleIn: Set[Global.icodes.BasicBlock]): Unit

    This method is invoked after one or more inlinings have been performed in basic blocks whose in-flow is non-bottom (this makes a difference later).

    This method is invoked after one or more inlinings have been performed in basic blocks whose in-flow is non-bottom (this makes a difference later). What we know about those inlinings is given by:

    - `staleOut`: These are the blocks where a callsite was inlined. For each callsite, all instructions in that block before the callsite were left in the block, and the rest moved to an `afterBlock`. The out-flow of these basic blocks is thus in general stale, that's why we'll add them to the TFA worklist.
    - `inlined` : These blocks were spliced into the method's CFG as part of inlining. Being new blocks, they haven't been visited yet by the typeflow analysis.
    - `staleIn` : These blocks are what `doInline()` calls `afterBlock`s, ie the new home for instructions that previously appeared after a callsite in a `staleOut` block.

    Based on the above information, we have to bring up-to-date the caches that `forwardAnalysis` and `blockTransfer` use to skip blocks and instructions. Those caches are `relevantBBs` and `isOnPerimeter` (for blocks) and `isOnWatchlist` and `lastInstruction` (for CALL_METHODs). Please notice that all `inlined` and `staleIn` blocks are reachable from `staleOut` blocks.

    The update takes place in two steps:

    (1) `staleOut foreach { so => putOnRadar(linearizer linearizeAt (m, so)) }` This results in initial populations for `relevantBBs` and `isOnWatchlist`. Because of the way `isPreCandidate` reuses previous decision-outcomes that are still valid, this already prunes some candidates standing no chance of being inlined.

    (2) `populatePerimeter()` Based on the CFG-subgraph determined in (1) as reflected in `relevantBBs`, this method detects some blocks whose typeflows aren't needed past a certain CALL_METHOD (not needed because none of its successors is relevant for the purposes of inlining, see `hasNoRelevantSuccs`). The blocks thus chosen are said to be "on the perimeter" of the CFG-subgraph. For each of them, its `lastInstruction` (after which no more typeflows are needed) is found.

47. #### val relevantBBs: Set[Global.icodes.BasicBlock]

48. #### val remainingCALLs: Map[CALL_METHOD, CallsiteInfo]

49. #### def run(): Unit

    Definition Classes
      MTFAGrowable → MethodTFA → DataFlowAnalysis

50. #### var shrinkedWatchlist: Boolean

51. #### var stat: Boolean

    collect statistics?

    collect statistics?

    Definition Classes
      DataFlowAnalysis

52. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

53. #### def toString(): String

    Creates a String representation of this object.

    Creates a String representation of this object. The default representation is platform dependent. On the java platform it is the concatenation of the class name, "@", and the object's hashcode in hexadecimal.

    returns

      a String representation of the object.

    Definition Classes
      AnyRef → Any

54. #### val visited: HashSet[P]

    Definition Classes
      DataFlowAnalysis

55. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

56. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

57. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

58. #### val warnIfInlineFails: Set[CALL_METHOD]

59. #### val worklist: Set[P]

    Definition Classes
      DataFlowAnalysis

60. #### def →[B](y: B): (MTFAGrowable, B)

    Implicit information
      This member is added by an implicit conversion from MTFAGrowable to ArrowAssoc[MTFAGrowable] performed by method ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Inherited from MethodTFA

### Inherited from DataFlowAnalysis[typeFlowLattice.type]

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from MTFAGrowable to any2stringadd[MTFAGrowable]

### Inherited by implicit conversion StringFormat from MTFAGrowable to StringFormat[MTFAGrowable]

### Inherited by implicit conversion Ensuring from MTFAGrowable to Ensuring[MTFAGrowable]

### Inherited by implicit conversion ArrowAssoc from MTFAGrowable to ArrowAssoc[MTFAGrowable]

### Ungrouped